@echo off

:: figure out what we are running on
set "winarch=%PROCESSOR_ARCHITECTURE%"
if "%winarch%"=="" set "winarch=unknown architecture"
if "%winarch%"=="AMD64" set "winarch=x86_64"
if "%winarch%"=="X86" set "winarch=x86"

for /f "tokens=4-5 delims=. " %%i in ('ver') do set winverbuild=%%i.%%j
if "%winverbuild%" == "10.0" set "winver=10/11"
if "%winverbuild%" == "6.4" set "winver=10 Technical Preview"
if "%winverbuild%" == "6.3" set "winver=8.1"
if "%winverbuild%" == "6.2" set "winver=8"
if "%winverbuild%" == "6.1" set "winver=7"
if "%winverbuild%" == "6.0" set "winver=Vista"

FOR /F "usebackq skip=2 tokens=3" %%A IN (`reg query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v EditionID 2^>nul`) DO set "winedition=%%A"

:: start
title Stella's Windows Activator
set "version=v2.1"
cls
echo [105mStella's Windows Activator[0m %version%
echo https://software.thatstel.la/software/batch-scripts/windows-activator
echo [92mFor Windows Vista through 11 - x86, x86_64, ARM, ARM64[0m
echo Running on Windows %winver% %winedition% %winarch%

echo.
echo Initializing...

::This section checks to ensure that you're running on a supported version of Windows

::This part checks if help was requested on the command line BEFORE checking for compatibility.
::jump names:
::helpcalled - /h or /? - Shows the help screen.
if "%1"=="/?" goto helpcalled
if "%1"=="/h" goto helpcalled
FOR %%G IN ("10.0"
            "6.3"
            "6.2"
            "6.1"
            "6.0") DO (
            IF /I "%winverbuild%"=="%%~G" GOTO support
)
:nomatchcheck
goto notsupport

:support
::This part processes any arguments that were input from the command line.
::jump names:
::helpcalled - /h or /? - Shows the help screen.
::quicklaunchp1 - /q - Skips the welcome screen, "quick" mode
if "%1"=="/?" goto helpcalled
if "%1"=="/h" goto helpcalled
if "%1"=="/q" goto quicklaunchp1
goto noargs

:noargs
echo.
echo Caught no valid arguments, running normally.
::This checks for administator rights.
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
	::Jumps to the Welcome screen where the user has to press a key to continue.
    goto confirmation
) ELSE (
    goto noadmin
)

:confirmation
echo.
echo Welcome! This batch file will activate your Windows %winver% %winedition% install.
echo Ensure you are connected to the internet before continuing.
echo.
echo Press any key to begin the activation process.
timeout.exe /t -1 > nul
::Jumps to the processing stage.
goto :beginprocessing

:quicklaunchp1
echo.
echo Caught quick mode argument ^(/q^), skipping user interaction.
::This checks for administator rights.
NET SESSION >nul 2>&1
IF %ERRORLEVEL% EQU 0 (
	::Jumps right to the actual activation, skipping the Welcome screen.
    goto beginprocessing
) ELSE (
    goto noadmin
)

:beginprocessing
echo.
echo Setting up...
if "%winverbuild%" == "10.0" goto process1011choosemethod
if "%winverbuild%" == "6.3" goto process81
if "%winverbuild%" == "6.2" goto process8
if "%winverbuild%" == "6.1" goto process7
if "%winverbuild%" == "6.0" goto processvista

:process1011choosemethod
:: TODO Ask the user whether they want to use KMS or HWID activation, only on Windows 10 or 11
:: For now it will automatically choose KMS as that's what is implemented
goto process1011kms

:process1011hwid
:: TODO Implement HWID activation
echo HWID not implemented.
exit 1

:process1011kms
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /upk > nul
if "%winedition%" == "Enterprise" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk NPPR9-FWDCX-D2C8J-H872K-2YT43 > nul
) else if "%winedition%" == "ProfessionalWorkstation" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk NRG8B-VKK3Q-CXVCJ-9G2XF-6Q84J > nul
) ELSE IF "%winedition%" == "Professional" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk W269N-WFGWX-YVC9B-4J6C9-T83GX > nul
) ELSE IF "%winedition%" == "Home" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk TX9XD-98N7V-6WMQ6-BX7FG-H8Q99 > nul
) ELSE (
    echo [91mError:[0m Unhandled edition %winedition%! Will default to using an Enterprise key.
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk NPPR9-FWDCX-D2C8J-H872K-2YT43 > nul
    echo        Activation in this manner may not work on %winver% %winedition% %winarch%
    echo        Please report this error and your Windows edition to Stella.
)

cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /skms kms8.msguides.com > nul
echo [92mReady to activate %winver% %winedition% with KMS.[0m
goto activatekms

:process81
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /upk > nul
if "%winedition%" == "Enterprise" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk MHF9N-XY6XB-WVXMC-BTDCT-MKKG7 > nul
) else if "%winedition%" == "EmbeddedIndustry" (
    :: EmbeddedIndustry uses an Embedded Industry Pro key
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk NMMPB-38DD4-R2823-62W8D-VXKJB > nul
) ELSE IF "%winedition%" == "Professional" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk GCRJD-8NW9H-F2CDX-CCM8D-9D6T9 > nul
) ELSE IF "%winedition%" == "Home" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk M9Q9P-WNJJT-6PXPY-DWX8H-6XWKK > nul
) ELSE (
    echo [91mError:[0m Unhandled edition %winedition%! Will default to using an Enterprise key.
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk MHF9N-XY6XB-WVXMC-BTDCT-MKKG7 > nul
    echo        Activation in this manner may not work on %winver% %winedition% %winarch%
    echo        Please report this error and your Windows edition to Stella.
)
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /skms kms8.msguides.com > nul
echo [92mReady to activate %winver% %winedition% with KMS.[0m
goto activatekms

:process8
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /upk > nul
if "%winedition%" == "Enterprise" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk 32JNW-9KQ84-P47T8-D8GGY-CWCK7 > nul
) ELSE IF "%winedition%" == "Professional" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk NG4HW-VH26C-733KW-K6F98-J8CK4 > nul
) ELSE IF "%winedition%" == "Home" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk BN3D2-R7TKB-3YPBD-8DRP2-27GG4 > nul
) ELSE (
    echo [91mError:[0m Unhandled edition %winedition%! Will default to using an Enterprise key.
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk 32JNW-9KQ84-P47T8-D8GGY-CWCK7 > nul
    echo        Activation in this manner may not work on %winver% %winedition% %winarch%
    echo        Please report this error and your Windows edition to Stella.
)
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /skms kms8.msguides.com > nul
echo [92mReady to activate %winver% %winedition% with KMS.[0m
goto activatekms

:process7
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /upk > nul
if "%winedition%" == "Enterprise" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk 33PXH-7Y6KF-2VJC9-XBBR8-HVTHH > nul
) ELSE IF "%winedition%" == "Professional" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk FJ82H-XT6CR-J8D7P-XQJJ2-GPDD4 > nul
) ELSE (
    echo [91mError:[0m Unhandled edition %winedition%! Will default to using an Enterprise key.
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk 33PXH-7Y6KF-2VJC9-XBBR8-HVTHH > nul
    echo        Activation in this manner may not work on %winver% %winedition% %winarch%
    echo        Please report this error and your Windows edition to Stella.
)
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /skms kms8.msguides.com > nul
echo [92mReady to activate %winver% %winedition% with KMS.[0m
goto activatekms

:processvista
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /upk > nul
if "%winedition%" == "Enterprise" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk VKK3X-68KWM-X2YGT-QR4M6-4BWMV > nul
) ELSE IF "%winedition%" == "Business" (
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk YFKBB-PQJJV-G996G-VWGXY-2V3X8 > nul
) ELSE (
    echo [91mError:[0m Unhandled edition %winedition%! Will default to using an Enterprise key.
    cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ipk VKK3X-68KWM-X2YGT-QR4M6-4BWMV > nul
    echo        Activation in this manner may not work on %winver% %winedition% %winarch%
    echo        Please report this error and your Windows edition to Stella.
)
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /skms kms8.msguides.com > nul
echo [92mReady to activate %winver% %winedition% with KMS.[0m
goto activatekms

:activatekms
echo.
echo Activating...
cscript.exe //nologo "%systemroot%\system32\slmgr.vbs" /ato > nul
timeout.exe /t 1 /nobreak > nul
goto finish

:finish
cls
echo [105mStella's Windows Activator[0m %version%
echo https://software.thatstel.la/software/batch-scripts/windows-activator
echo [92mFor Windows Vista through 11 - x86, x86_64, ARM, ARM64[0m
echo Running on Windows %winver% %winedition% %winarch%
echo.
echo [92mActivation attempt complete.[0m
echo.
echo Please check the Activation page in Settings/Control Panel for more details.
::checks if the user used the quick mode, skips final 'press to exit'.
if "%1"=="/q" goto eof
echo.
echo Press any key to exit.
timeout.exe /t -1 > nul
goto eof

:noadmin
echo.
echo [91mError:[0m
echo Stella's Windows Activator requires being run with administrator rights.
echo.
echo Close this window and rerun the batch file as administrator.
echo You can do this by right clicking the file and selecting 'Run as Administrator'.
echo.
echo Execution of this batch file will now stop.
timeout.exe /t -1 /nobreak > nul
timeout.exe /t -1 /nobreak > nul
exit

:notsupport
echo.
echo [91mError:[0m
echo Stella's Windows Activator does not support Windows %winver% %winarch%!
echo.
echo The activator can only run on Windows Vista through 11 on x86, x86_64, ARM and ARM64 architectures
echo Novelty editions like Technical Previews are not supported.
echo.
echo Execution of this batch file will now stop.
timeout.exe /t -1 /nobreak > nul
timeout.exe /t -1 /nobreak > nul
exit

:helpcalled
echo.
echo Caught help argument, showing help.
echo.
echo [105mStella's Windows Activator Help[0m
echo.
echo Supported OSes ----------------------------------------------------------------------------------------------
echo [93mIf the activator is run on an edition of Windows it doesn't support, it will fall back to activating as the[0m
echo [93mhighest possible edition, which most of the time will be Enterprise.[0m
echo       Version     ^|     Editions Supported
echo  -----------------^|-----------------------------------------------------------------------------------------
echo       10/11       ^|   Enterprise, ProfessionalWorkstation, Professional and Home
echo        8.1        ^|   Enterprise, EmbeddedIndustry, Professional and Home
echo         8         ^|   Enterprise, Professional, Home
echo         7         ^|   Enterprise, Professional
echo       Vista       ^|   Enterprise, Business
echo.
echo.
echo Arguments ---------------------------------------------------------------------------------------------------
echo The activator supports arguments, so you can customize its behaviour. Below, you can see the supported
echo arguments. 
echo [93mIf an invalid argument is specified, it will be ignored and the activator will continue as if there was no[0m
echo [93margument specified.[0m
echo.
echo Example of calling this batch file with the '^/q' argument:
echo [96m^C:\Path\To\Activator.bat ^/q[0m
echo This will launch the activator in "quick" mode which skips all user interaction.
echo.
echo Below is a table of the supported arguments and their effects if used.
echo   Input Argument  ^|    Result
echo  -----------------^|-----------------------------------------------------------------------------------------
echo       ^<none^>      ^|  Runs the activator normally, with all user interaction prompts
echo      ^/h or ^/^?     ^|  Shows this help screen and exits.
echo         ^/q        ^|  "Quick" mode, skips all user interaction. Good for using inside other scripts.
echo.
echo There are no other arguments or configuration options besides these.
echo.
echo Exiting...
goto eof

:eof
endlocal